/* chkbg.p
 *
 * check to see if we should be using a special background color
 *
 */

define new global shared variable pt_shortName      as character no-undo.
define new global shared variable pt_envDescription as character no-undo.

define variable bgConfigLine as character no-undo.

define stream inStrm.

file-info:file-name = "etc/background.cfg".
if file-info:full-pathname <> ? then
  do:

    input stream inStrm from value( file-info:full-pathname ).

    repeat:

      import stream inStrm unformatted bgConfigLine.

      if bgConfigLine begins "#" or bgConfigLine = "" or bgConfigLine = ? then next.

      /* first successful lookup wins
       */ 

      if pt_shortname <> "" and entry( 1, bgConfigLine, "|" ) = pt_shortname then
        do:
          terminal = entry( 2, bgConfigLine, "|" ).
          if num-entries( bgConfigLine, "|" ) > 2 then
            pt_envDescription = entry( 3, bgConfigLine, "|" ).
          leave.
        end.

      if pdbname( 1 ) <> ? and entry( 1, bgConfigLine, "|" ) = pdbname( 1 ) then
        do:
          terminal = entry( 2, bgConfigLine, "|" ).
          if num-entries( bgConfigLine, "|" ) > 2 then
            pt_envDescription = entry( 3, bgConfigLine, "|" ).
          leave.
        end.

    end.

    input stream inStrm close.

  end.

return.
