/* getprocdll.p
 *
 * use a DLL to get a process list (windows)
 *
 */

define input parameter matchList as character no-undo.			/* "_progres,p util~\pt3agent"			*/

define new global shared variable dbgMode as integer no-undo.

define new global shared temp-table tt_process no-undo
  field pid     as character
  field cmdLine as character
  index pid-idx is unique primary pid
.

define variable commandLine as character no-undo.
define variable xpid        as character no-undo.

define variable i  as integer no-undo.
define variable n  as integer no-undo.
define variable ok as logical no-undo.

n = num-entries( matchList ).

/* the System.Management class requires OE11+ so hide it from OE10
 * also, since the pre-processor will mess up DEBUG line numbers,
 * keep this code as close to the end as we can
 */

if dbgMode >= 3 then
  message now "getProcessList, dll call: {&OPSYS}" proversion.

&IF OPSYS BEGINS "WIN" AND DECIMAL(SUBSTRING(PROVERSION,1,INDEX(PROVERSION,".") + 1)) >= 11.0 &THEN

define variable mngmtClass as System.Management.ManagementClass no-undo.

mngmtClass = new System.Management.ManagementClass( "Win32_Process" ).

{lib/foreach.i System.Management.ManagementObject processObject in mngmtClass:GetInstances()}

  xpid = unbox( processObject["PROCESSID"] ).
  commandLine = unbox( processObject["CommandLine"] ).

  if commandLine = "" or commandLine = ? then next.

  if dbgMode >= 5 then
    message now "getProcessList, dll:" xpid commandLine.

  ok = yes.
  matchLoop: do i = 1 to n:
    if dbgMode >= 5 then
      message "checking:" entry( i, matchList ) index( commandLine, entry( i, matchList )).
    if index( commandLine, entry( i, matchList )) = 0 then
      do:
        ok = no.
        if dbgMode >= 4 then
          message now substitute( 'getProcessList: rejected "&1" was not matched', entry( i, matchList )). 
        leave matchLoop.
      end.
  end.

  if ok = yes then
    do:

      find tt_process where tt_process.pid = xpid no-error.
      if available tt_process then
        do:
          message now "getProcessList: PID already exists in tt_process!" xpid commandLine.
          next.
        end.

      create tt_process.
      assign
        tt_process.pid = xpid
        tt_process.cmdLine = commandLine
      .

    end.

end.	/* foreach.i	*/

&ELSE

message now "getProcessList, dll call, unqualified system: {&OPSYS}" proversion.

&ENDIF

return.
